---
title: "Algorithmique"
subtitle: "Exercices sur la récursivité"
geometry: margin=2.5cm
---

## Exercice 1

Soit la fonction C suivante :

```C
int quoi(int a, int b){
  if(b==1){
    return a;
  }
  return a + quoi(a, b-1);
}
```

Que retourne `f(3, 5)` ? Quelle opération effectue cette fonction ? Expliquez votre réponse.


## Exercice 2

Ecrire une fonction récursive `count`, qui prend en entrée un caractère `c` et une chaîne de caractères `str` et retourne le nombre d'occurence de `c` dans `str`; 

## Exercice 3

Réecrire la fonction suivante sous forme récursive :

```C
int somme(int a){
  int res = 0;
  for(int i=0; i<a; i++){
    res += i;
  }
  return res;
}
```

## Exercice 4

Soit une image en noir et blanc représentée par un tableau à deux dimensions d'entiers. Chaque pixel est représenté par une case du tableau, une valeur de 0 représente un pixel blanc et une valeur de 1 représente un pixel noir. Ecrire une fonction récursive `fill` permettant de remplir (mettre à 1) une zone de pixels délimitée par une forme. La fonction prendra en paramètre le tableau à remplir, la taille du tableau et la coordonnée du pixel de départ.

![Une forme en noir et blanc.](figs/shape.jpg){height=30%}

![Résultat après avoir appelé la fonction `fill` sur un pixel à l'intérieur de la forme.](figs/inside.jpg){height=30%}

![Résultat après avoir appelé la fonction `fill` sur un pixel à l'extérieur de la forme.](figs/outside.jpg){height=30%}