# Tableaux

## Exercice 2

Écrire une fonction qui a en paramètre un tableau de nombres entiers et qui renvoie le nombre d'occurrences du nombre 10. Cette fonction devra parcourir le tableau sans utiliser de pointeur. 

## Exercice 3

Ecrivez en C une fonction `fusion` qui prend en paramètre trois tableaux à 1 dimension
`tab1`, `tab2` et `res`. `tab1` et `tab2` sont de taille n (passé en paramètre) tandis que `res` est de taille 2n.

Les taleaux contiennent des entiers et la fonction ne retourne rien. On suppose que les tableaux
`tab1` et `tab2` sont déjà triés. La fonction `fusion` écrit de manière ordonnée les éléments de `tab1` et `tab2` dans `res` comme illustré ci dessous. Vous ne devez parcour chaque tableau qu'une seule fois !

tab1 : 1, 3, 5, 10

tab2 : -2, -1, 4, 12

res : -2, -1, 1, 3, 4, 5, 10, 12

## Exercice 4

Ecire une fonction `initialise` qui prend un tableau à deux dimensions d'entiers en paramètre et l'initialise de la façon suivante. L'exemple a 6 lignes et 5 colonnes, mais la fonction doit fonctionner avec n'importe quelle taille de tableau.


|  |  |  |  |  |
|:---:|:---:|:---:|:---:|:---:|
| 0 | 1 | 2 | 3 | 4 |
| 2 | 3 | 4 | 5 | 6 |
| 4 | 5 | 6 | 7 | 8 |
| 6 | 7 | 8 | 9 | 10 |
| 8 | 9 | 10 | 11 | 12 |
| 10 | 11 | 11 | 12 | 13 |


## Exercice 5

Ecrire une fonction `initialise` qui initialise un tableau à deux dimensions d'entiers en mettant dans chaque case la somme des distances aux bords verticaux et horizontaux. On prendra dans chaun des cas (vertical et horizontal) le bord le plus proche. 

Il est interdit d'utiliser des fonctions prédéfinies comme `min` ou `max`.

|  |  |  |  |  |  |  |  |  |  |
|:---:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|
| 0 | 1 | 2 | 3 | 4 | 4 | 3 | 2 | 1 | 0 |
| 1 | 2 | 3 | 4 | 5 | 5 | 4 | 3 | 2 | 1 |
| 2 | 3 | 4 | 5 | 6 | 6 | 5 | 4 | 3 | 2 |
| 1 | 2 | 3 | 4 | 5 | 5 | 4 | 3 | 2 | 1 |
| 0 | 1 | 2 | 3 | 4 | 4 | 3 | 2 | 1 | 0 |

## Exercice 6

On considère des tableaux à deux dimensions contenant des -1 et des 1.

Ecrire une fonction `update` qui prend en paramètre un tableau `tab_in` à deux dimensions contenant des -1 et des 1 et un tableau `tab_out` de même taille et le remplit de la façon suivante :

  - L'élément d'index `(i, j)` de `tab_out` prend la valeur :
    - majoritaire des 8 éléments voisins (haut, bas, gauche, droite plus les 4 diagonales) de l'élément d'index `(i, j)` de `tab_in` s'il y a une majorité;
    - la valeur opposée à celle de l'élément d'index `(i, j)` de `tab_in` si il y a égalité.

Pour les élément au bord, on considère qu'il y a périodicité :
  - le voisin du bord du haut est celui du bas et inversement,
  - le voisin du bord de gauche est delui de droite et inversement.
