---
title: "Programmation séquentielle"
subtitle: "Série 5 - Couverture de la reine"
date: 11.10.2022
---

# Buts

- Utilisation d'une tableau bidimensionnel.

# Énoncé

La déclaration d’un tableau bidimensionnel se faisant par exemple par la déclaration
suivante :

```C
const int taille = 8;
char E[taille][taille];
```

Vous devez afficher la couverture d'une reine sur un échiquer de taille 8x8. Le programme demandera à l'utilisateur la position de la reine au format `lettre chiffre`.

Exemple pour une position de la reine (E 6) dont le contenu est accédé par `E[3][5]`:

```
H . . * . . * . .
G . . . * . * . *
F . . . . * * * .
E * * * * * R * *
D . . . . * * * .
C . . . * . * . *
B . . * . . * . .
A . * . . . * . .
1 2 3 4 5 6 7 8
```

Décomposez la résolution du problème en plusieurs fonctions. Par exemple, faites une fonction pour l'affichage du tableau.

# Partie bonus

Cette partie n'est pas obligatoire. Vous pouvez la faire si vous souhaitez aller plus loin.

## Le problème des 8 reines (pour les plus avancés)

A partir de la position d'une reine, le programme doit trouver où placer 7 autres reines sur l'échiquier sans qu'elles ne se menacent mutuellement.

## Le problème des N reines

Pour aller plus loin, réfléchissez à un algorithme permettant de gérer le cas général de N reines sur un échiquier de N cases de côté. Peut-on réger 1000, 10000, 100000 reines ?

