# Module d'algorithmie et programmation - hepia ISC soir 2022-2023

## Champs du test 1 du 24.01.2022

  - Variables, tests, boucles, fonctions
  - Tableaux statiques et dynamiques
  - Chaînes de caractères
  - Struct et enum
  - Algorithmes simples
  - Recursivité
  - Pointeurs et mémoire dynamique
  - Tris
  - Piles (sous forme de tableau et de liste)

## Intervenants 

### Enseignants

  * **Pierre Künzli**
    * pierre.kunzli@hesge.ch
  * **Christophe Charpilloz**
    * christophe.charpilloz@hesge.ch

### Assistant

  * **David Gonzalez**
    * david.dg.gonzalez@hesge.ch
    
## Horaires

Salle A534

  * Mardi soir de 18h30 à 21h30
  * Jeudi soir de 17h à 18h30

## Espace de discussion du cours

[https://matrix.to/#/!xoHIwwGcPDQjZBQiOZ:matrix.org?via=matrix.org](https://matrix.to/#/!xoHIwwGcPDQjZBQiOZ:matrix.org?via=matrix.org)

Client Matrix Element : [https://element.io/](https://element.io/)

## Libre service

En A406 (ou A432 ou A433)

  - Lundi de 12h à 13h
  - Mercredi de 17h à 18h
  - Jeudi de 12h à 13h
  - Vendredi de 12h à 13h

## Références

### Programmation

[Le C en 20 heures](https://c.developpez.com/cours/20-heures/)

[Modern C](https://gustedt.gitlabpages.inria.fr/modern-c/)


### Algorithmique

[Introduction to algorithms](https://mitpress.mit.edu/9780262046305/introduction-to-algorithms/)

### Des exercices en plus

[exercism](https://exercism.org/)
