# Piles

## Exercice 1

Trier le tableau trier le tableau `[2, 10, 5, 20, 15, 1, 7]` avec le tri à deux piles. A chaque étape, donner l'état des deux piles gauche et droite.

## Exercice 2

Interpréter l'expression postfixe `2 3 4 * * 2 +` à l'aide d'une pile. Spécifier pour chaque étape la caractère lu, l'état de la pile et l'opération effectuée.

# Exercice 3

Ecrire un programme `tri.c` qui trie une suite de nombres entiers à l'aide de deux piles de nombres entiers. On suppose que la suite de nombre est codée en dur dans le programme. Lorsqu'il est exécuté, le programme affiche la suite de nombres originale, la trie puis affiche les nombres dans l'ordre croissant.

On considère qu'on a à disposition une librairie `pile_int.h` pour manipuler des piles de nombres entiers. Elle contient notamment les fonctions suivantes :

```C
//Creer une pile vide
pile pile_creer();
//Empiler un élement au sommet de la pile 
void pile_empiler(pile* stack,int val); 
//Dépiler un élément de la pile 
int pile_depiler(pile* stack); 
//Consulter l'élément au sommet de la pile 
int pile_sommet(pile stack); 
//Tester si la pile est vide 
bool pile_est_vide(pile stack);
```

Voici le programme principal à compléter :

```C
#include <stdio.h>
#include <stdlib.h>
#include "pile_string.h"
void main() {
   // piles pour faire le tri
   pile gauche = pile_creer();
   pile droite = pile_creer(); 
   int taille = 7;
   int nombres[] = {4, 12, 1, 6, 7, 19, 23};
   // à compléter
}
```